<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
"mybatis-3-mapper.dtd">
<mapper namespace="com.mortals.xhx.module.feedback.dao.ibatis.FeedbackQuestionDaoImpl">

    <!-- 字段和属性映射 -->
    <resultMap type="FeedbackQuestionEntity" id="FeedbackQuestionEntity-Map">
            <id  property="id" column="id" />
            <result property="feedbackId" column="feedbackId" />
            <result property="content" column="content" />
            <result property="questionType" column="questionType" />
            <result property="require" column="require" />
            <result property="style" column="style" />
            <result property="remark" column="remark" />
            <result property="createUserId" column="createUserId" />
            <result property="createTime" column="createTime" />
            <result property="updateUserId" column="updateUserId" />
            <result property="updateTime" column="updateTime" />
            <collection property="feedbackOptionList" column="id" ofType="FeedbackOptionEntity" javaType="ArrayList" select="getFeedbackOptionByQuestionId"></collection>
    </resultMap>
    <resultMap type="FeedbackOptionEntity" id="FeedbackOptionEntity-Map">
            <result property="id" column="id" />
            <result property="questionId" column="questionId" />
            <result property="content" column="content" />
            <result property="remark" column="remark" />
            <result property="createUserId" column="createUserId" />
            <result property="createTime" column="createTime" />
            <result property="updateUserId" column="updateUserId" />
            <result property="updateTime" column="updateTime" />
    </resultMap>


    <!-- 表所有列 -->
    <sql id="_columns">
        <trim suffixOverrides="," suffix="">
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('id') or colPickMode == 1 and data.containsKey('id')))">
                    a.id,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('feedbackId') or colPickMode == 1 and data.containsKey('feedbackId')))">
                    a.feedbackId,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('content') or colPickMode == 1 and data.containsKey('content')))">
                    a.content,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('questionType') or colPickMode == 1 and data.containsKey('questionType')))">
                    a.questionType,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('require') or colPickMode == 1 and data.containsKey('require')))">
                    a.`require`,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('style') or colPickMode == 1 and data.containsKey('style')))">
                    a.style,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('remark') or colPickMode == 1 and data.containsKey('remark')))">
                    a.remark,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('createUserId') or colPickMode == 1 and data.containsKey('createUserId')))">
                    a.createUserId,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('createTime') or colPickMode == 1 and data.containsKey('createTime')))">
                    a.createTime,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('updateUserId') or colPickMode == 1 and data.containsKey('updateUserId')))">
                    a.updateUserId,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('updateTime') or colPickMode == 1 and data.containsKey('updateTime')))">
                    a.updateTime,
                </if>
        </trim>
    </sql>
    <!-- 子表所有列 -->
    <sql id="_columns_sub">
        <trim suffixOverrides="," suffix="">
            b.id,b.questionId,b.content,b.remark,b.createUserId,b.createTime,b.updateUserId,b.updateTime,
        </trim>
    </sql>
    <!-- 新增 区分主键自增加还是业务插入 -->
    <insert id="insert" parameterType="FeedbackQuestionEntity"  useGeneratedKeys="true" keyProperty="id">
        insert into mortals_xhx_feedback_question
        (feedbackId,content,questionType,`require`,style,remark,createUserId,createTime,updateUserId,updateTime)
        VALUES
        (#{feedbackId},#{content},#{questionType},#{require},#{style},#{remark},#{createUserId},#{createTime},#{updateUserId},#{updateTime})
    </insert>

    <!-- 批量新增 -->
    <insert id="insertBatch" parameterType="paramDto">
        insert into mortals_xhx_feedback_question
        (feedbackId,content,questionType,`require`,style,remark,createUserId,createTime,updateUserId,updateTime)
        VALUES
        <foreach collection="data.dataList" item="item" index="index" separator="," >
            (#{item.feedbackId},#{item.content},#{item.questionType},#{item.require},#{item.style},#{item.remark},#{item.createUserId},#{item.createTime},#{item.updateUserId},#{item.updateTime})
        </foreach>
    </insert>


    <!-- 根据ParamDto更新 -->
    <update id="update" parameterType="paramDto">
        update mortals_xhx_feedback_question as a
        set
        <trim suffixOverrides="," suffix="">
            <if test="(colPickMode==0 and data.containsKey('feedbackId')) or (colPickMode==1 and !data.containsKey('feedbackId'))">
                a.feedbackId=#{data.feedbackId},
            </if>
            <if test="(colPickMode==0 and data.containsKey('feedbackIdIncrement')) or (colPickMode==1 and !data.containsKey('feedbackIdIncrement'))">
                a.feedbackId=ifnull(a.feedbackId,0) + #{data.feedbackIdIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('content')) or (colPickMode==1 and !data.containsKey('content'))">
                a.content=#{data.content},
            </if>
            <if test="(colPickMode==0 and data.containsKey('questionType')) or (colPickMode==1 and !data.containsKey('questionType'))">
                a.questionType=#{data.questionType},
            </if>
            <if test="(colPickMode==0 and data.containsKey('questionTypeIncrement')) or (colPickMode==1 and !data.containsKey('questionTypeIncrement'))">
                a.questionType=ifnull(a.questionType,0) + #{data.questionTypeIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('require')) or (colPickMode==1 and !data.containsKey('require'))">
                a.`require`=#{data.require},
            </if>
            <if test="(colPickMode==0 and data.containsKey('requireIncrement')) or (colPickMode==1 and !data.containsKey('requireIncrement'))">
                a.`require`=ifnull(a.`require`,0) + #{data.requireIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('style')) or (colPickMode==1 and !data.containsKey('style'))">
                a.style=#{data.style},
            </if>
            <if test="(colPickMode==0 and data.containsKey('remark')) or (colPickMode==1 and !data.containsKey('remark'))">
                a.remark=#{data.remark},
            </if>
            <if test="(colPickMode==0 and data.containsKey('createUserId')) or (colPickMode==1 and !data.containsKey('createUserId'))">
                a.createUserId=#{data.createUserId},
            </if>
            <if test="(colPickMode==0 and data.containsKey('createUserIdIncrement')) or (colPickMode==1 and !data.containsKey('createUserIdIncrement'))">
                a.createUserId=ifnull(a.createUserId,0) + #{data.createUserIdIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('createTime')) or (colPickMode==1 and !data.containsKey('createTime'))">
                a.createTime=#{data.createTime},
            </if>
            <if test="(colPickMode==0 and data.containsKey('updateUserId')) or (colPickMode==1 and !data.containsKey('updateUserId'))">
                a.updateUserId=#{data.updateUserId},
            </if>
            <if test="(colPickMode==0 and data.containsKey('updateUserIdIncrement')) or (colPickMode==1 and !data.containsKey('updateUserIdIncrement'))">
                a.updateUserId=ifnull(a.updateUserId,0) + #{data.updateUserIdIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('updateTime')) or (colPickMode==1 and !data.containsKey('updateTime'))">
                a.updateTime=#{data.updateTime},
            </if>
        </trim>
        <trim suffixOverrides="where" suffix="">
            where
            <trim prefixOverrides="and" prefix="">
                <include refid="_condition_"/>
            </trim>
        </trim>
    </update>
    <!-- 批量更新 -->
    <update id="updateBatch" parameterType="paramDto">
        update mortals_xhx_feedback_question as a
        <trim prefix="set" suffixOverrides=",">
                        <trim prefix="feedbackId=(case" suffix="ELSE feedbackId end),">
                            <foreach collection="data.dataList" item="item" index="index" separator="" >
                                <choose>
                                    <when test="(colPickMode==0 and item.containsKey('feedbackId')) or (colPickMode==1 and !item.containsKey('feedbackId'))">
                                        when a.id=#{item.id} then #{item.feedbackId}
                                    </when>
                                    <when test="(colPickMode==0 and item.containsKey('feedbackIdIncrement')) or (colPickMode==1 and !item.containsKey('feedbackIdIncrement'))">
                                        when a.id=#{item.id} then ifnull(a.feedbackId,0) + #{item.feedbackIdIncrement}
                                    </when>
                                </choose>
                            </foreach>
                        </trim>
                <trim prefix="content=(case" suffix="ELSE content end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('content')) or (colPickMode==1 and !item.containsKey('content'))">
                            when a.id=#{item.id} then #{item.content}
                        </if>
                    </foreach>
                </trim>
                        <trim prefix="questionType=(case" suffix="ELSE questionType end),">
                            <foreach collection="data.dataList" item="item" index="index" separator="" >
                                <choose>
                                    <when test="(colPickMode==0 and item.containsKey('questionType')) or (colPickMode==1 and !item.containsKey('questionType'))">
                                        when a.id=#{item.id} then #{item.questionType}
                                    </when>
                                    <when test="(colPickMode==0 and item.containsKey('questionTypeIncrement')) or (colPickMode==1 and !item.containsKey('questionTypeIncrement'))">
                                        when a.id=#{item.id} then ifnull(a.questionType,0) + #{item.questionTypeIncrement}
                                    </when>
                                </choose>
                            </foreach>
                        </trim>
                        <trim prefix="`require`=(case" suffix="ELSE `require` end),">
                            <foreach collection="data.dataList" item="item" index="index" separator="" >
                                <choose>
                                    <when test="(colPickMode==0 and item.containsKey('require')) or (colPickMode==1 and !item.containsKey('require'))">
                                        when a.id=#{item.id} then #{item.require}
                                    </when>
                                    <when test="(colPickMode==0 and item.containsKey('requireIncrement')) or (colPickMode==1 and !item.containsKey('requireIncrement'))">
                                        when a.id=#{item.id} then ifnull(a.`require`,0) + #{item.requireIncrement}
                                    </when>
                                </choose>
                            </foreach>
                        </trim>
                <trim prefix="style=(case" suffix="ELSE style end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('style')) or (colPickMode==1 and !item.containsKey('style'))">
                            when a.id=#{item.id} then #{item.style}
                        </if>
                    </foreach>
                </trim>
                <trim prefix="remark=(case" suffix="ELSE remark end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('remark')) or (colPickMode==1 and !item.containsKey('remark'))">
                            when a.id=#{item.id} then #{item.remark}
                        </if>
                    </foreach>
                </trim>
                        <trim prefix="createUserId=(case" suffix="ELSE createUserId end),">
                            <foreach collection="data.dataList" item="item" index="index" separator="" >
                                <choose>
                                    <when test="(colPickMode==0 and item.containsKey('createUserId')) or (colPickMode==1 and !item.containsKey('createUserId'))">
                                        when a.id=#{item.id} then #{item.createUserId}
                                    </when>
                                    <when test="(colPickMode==0 and item.containsKey('createUserIdIncrement')) or (colPickMode==1 and !item.containsKey('createUserIdIncrement'))">
                                        when a.id=#{item.id} then ifnull(a.createUserId,0) + #{item.createUserIdIncrement}
                                    </when>
                                </choose>
                            </foreach>
                        </trim>
                <trim prefix="createTime=(case" suffix="ELSE createTime end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('createTime')) or (colPickMode==1 and !item.containsKey('createTime'))">
                            when a.id=#{item.id} then #{item.createTime}
                        </if>
                    </foreach>
                </trim>
                        <trim prefix="updateUserId=(case" suffix="ELSE updateUserId end),">
                            <foreach collection="data.dataList" item="item" index="index" separator="" >
                                <choose>
                                    <when test="(colPickMode==0 and item.containsKey('updateUserId')) or (colPickMode==1 and !item.containsKey('updateUserId'))">
                                        when a.id=#{item.id} then #{item.updateUserId}
                                    </when>
                                    <when test="(colPickMode==0 and item.containsKey('updateUserIdIncrement')) or (colPickMode==1 and !item.containsKey('updateUserIdIncrement'))">
                                        when a.id=#{item.id} then ifnull(a.updateUserId,0) + #{item.updateUserIdIncrement}
                                    </when>
                                </choose>
                            </foreach>
                        </trim>
                <trim prefix="updateTime=(case" suffix="ELSE updateTime end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('updateTime')) or (colPickMode==1 and !item.containsKey('updateTime'))">
                            when a.id=#{item.id} then #{item.updateTime}
                        </if>
                    </foreach>
                </trim>
        </trim>
        where id in
        <foreach collection="data.dataList" item="item" index="index" open="(" separator="," close=")">
            #{item.id}
        </foreach>
    </update>
    <!-- 根据主健查询 -->
    <select id="getByKey" parameterType="paramDto" resultMap="FeedbackQuestionEntity-Map">
        select <include refid="_columns"/>
        from mortals_xhx_feedback_question as a
        where a.id=#{condition.id}
    </select>
    <!-- 根据主健删除 -->
    <delete id="deleteByKey" parameterType="paramDto">
        delete a.* from mortals_xhx_feedback_question as a where a.id=#{condition.id}
    </delete>
    <!-- 根据主健删除一批，针对单一主健有效 -->
    <delete id="deleteByKeys">
        delete from mortals_xhx_feedback_question where id in
        <foreach collection="array" item="item" index="index" open="(" separator="," close=")">
            #{item}
        </foreach>
    </delete>
    <!-- 根据主健列表删除一批，针对单一主健有效 -->
    <delete id="deleteByKeyList">
        delete from mortals_xhx_feedback_question where id in
        <foreach collection="list" item="item" index="index" open="(" separator="," close=")">
            #{item}
        </foreach>
    </delete>

    <!-- 根据对象列表删除一批，针对单一主健有效 -->
    <delete id="deleteByEntityList">
        delete from mortals_xhx_feedback_question where id in
        <foreach collection="list" item="item" index="index" open="(" separator="," close=")">
            #{item.id}
        </foreach>
    </delete>
    <!-- 根据paramDto删除一批 -->
    <delete id="deleteByMap" parameterType="paramDto">
        delete a.* from mortals_xhx_feedback_question as a
        <trim suffixOverrides="where" suffix="">
            where
            <trim prefixOverrides="and" prefix="">
                <include refid="_condition_"/>
            </trim>
        </trim>
    </delete>
    <!-- 获取列表 -->
    <select id="getList" parameterType="paramDto" resultMap="FeedbackQuestionEntity-Map">
        select <include refid="_columns"/>
        from mortals_xhx_feedback_question as a
        <trim suffixOverrides="where" suffix="">
            where
            <trim prefixOverrides="and" prefix="">
                <include refid="_condition_"/>
            </trim>
        </trim>
        <include refid="_orderCols_"/>
    </select>
    <!-- 获取子列表 -->
    <select id="getFeedbackOptionByQuestionId" parameterType="java.lang.Long" resultMap="FeedbackOptionEntity-Map">
        select <include refid="_columns_sub"/>
        from mortals_xhx_feedback_option as b
        <trim suffixOverrides="where" suffix="">
            where b.questionId = #{id}
        </trim>
    </select>



    <!-- 获取 -->
    <select id="getListCount" parameterType="paramDto" resultType="int">
        select count(1)
        from mortals_xhx_feedback_question as a
        <trim suffixOverrides="where" suffix="">
            where
            <trim prefixOverrides="and" prefix="">
                <include refid="_condition_"/>
            </trim>
        </trim>
    </select>
    <!-- 条件映射 -->
    <sql id="_condition_">
        <if test="condition != null and !condition.isEmpty()">
            <!-- 条件映射-普通条件 -->
            <include refid="_condition_param_">
                <property name="_conditionParam_" value="condition"/>
                <property name="_conditionType_" value="and"/>
            </include>
            <!-- 条件映射-集合之间使用AND，集合中元素使用OR-(list[0].1 or list[0].2) and (list[1].3 or list[1].4) -->
            <if test="condition.containsKey('andConditionList') and !condition.andConditionList.isEmpty()">
                and
                <foreach collection="condition.andConditionList" open="(" close=")" index="index" item="andCondition" separator=" and ">
                    <trim prefixOverrides="or" prefix="(" suffix=")">
                        <include refid="_condition_param_">
                            <property name="_conditionParam_" value="andCondition"/>
                            <property name="_conditionType_" value="or"/>
                        </include>
                    </trim>
                </foreach>
            </if>
            <!-- 条件映射-集合之间使用OR，集合中元素使用AND-(list[0].1 and list[0].2) or (list[1].3 and list[1].4) -->
            <if test="condition.containsKey('orConditionList') and !condition.orConditionList.isEmpty()">
                and
                <foreach collection="condition.orConditionList" open="(" close=")" index="index" item="orCondition" separator=" or ">
                    <trim prefixOverrides="and" prefix="(" suffix=")">
                        <include refid="_condition_param_">
                            <property name="_conditionParam_" value="orCondition"/>
                            <property name="_conditionType_" value="and"/>
                        </include>
                    </trim>
                </foreach>
            </if>
        </if>
    </sql>
    <!-- 条件映射-代参数 -->
    <sql id="_condition_param_">
        <bind name="conditionParamRef" value="${_conditionParam_}"/>
        <if test="conditionParamRef.containsKey('id')">
            <if test="conditionParamRef.id != null">
                ${_conditionType_} a.id=#{${_conditionParam_}.id}
            </if>
        </if>
            <if test="conditionParamRef.containsKey('id')">
                <if test="conditionParamRef.id != null ">
                    ${_conditionType_} a.id = #{${_conditionParam_}.id}
                </if>
                <if test="conditionParamRef.id == null">
                    ${_conditionType_} a.id is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('idList') and conditionParamRef.idList.size() > 0">
                ${_conditionType_} a.id in
                <foreach collection="conditionParamRef.idList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('idNotList') and conditionParamRef.idNotList.size() > 0">
                ${_conditionType_} a.id not in
                <foreach collection="conditionParamRef.idNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('idStart') and conditionParamRef.idStart != null">
                ${_conditionType_} a.id <![CDATA[ >= ]]> #{${_conditionParam_}.idStart}
            </if>
            <if test="conditionParamRef.containsKey('idEnd') and conditionParamRef.idEnd != null">
                ${_conditionType_} a.id <![CDATA[ <= ]]> #{${_conditionParam_}.idEnd}
            </if>

            <if test="conditionParamRef.containsKey('feedbackId')">
                <if test="conditionParamRef.feedbackId != null ">
                    ${_conditionType_} a.feedbackId = #{${_conditionParam_}.feedbackId}
                </if>
                <if test="conditionParamRef.feedbackId == null">
                    ${_conditionType_} a.feedbackId is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('feedbackIdList') and conditionParamRef.feedbackIdList.size() > 0">
                ${_conditionType_} a.feedbackId in
                <foreach collection="conditionParamRef.feedbackIdList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('feedbackIdNotList') and conditionParamRef.feedbackIdNotList.size() > 0">
                ${_conditionType_} a.feedbackId not in
                <foreach collection="conditionParamRef.feedbackIdNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('feedbackIdStart') and conditionParamRef.feedbackIdStart != null">
                ${_conditionType_} a.feedbackId <![CDATA[ >= ]]> #{${_conditionParam_}.feedbackIdStart}
            </if>
            <if test="conditionParamRef.containsKey('feedbackIdEnd') and conditionParamRef.feedbackIdEnd != null">
                ${_conditionType_} a.feedbackId <![CDATA[ <= ]]> #{${_conditionParam_}.feedbackIdEnd}
            </if>


            <if test="conditionParamRef.containsKey('content')">
                <if test="conditionParamRef.content != null and conditionParamRef.content != ''">
                    ${_conditionType_} a.content like #{${_conditionParam_}.content}
                </if>
                <if test="conditionParamRef.content == null">
                    ${_conditionType_} a.content is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('contentList') and conditionParamRef.contentList.size() > 0">
                ${_conditionType_} a.content in
                <foreach collection="conditionParamRef.contentList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('contentNotList') and conditionParamRef.contentNotList.size() > 0">
                ${_conditionType_} a.content not in
                <foreach collection="conditionParamRef.contentNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('questionType')">
                <if test="conditionParamRef.questionType != null ">
                    ${_conditionType_} a.questionType = #{${_conditionParam_}.questionType}
                </if>
                <if test="conditionParamRef.questionType == null">
                    ${_conditionType_} a.questionType is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('questionTypeList') and conditionParamRef.questionTypeList.size() > 0">
                ${_conditionType_} a.questionType in
                <foreach collection="conditionParamRef.questionTypeList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('questionTypeNotList') and conditionParamRef.questionTypeNotList.size() > 0">
                ${_conditionType_} a.questionType not in
                <foreach collection="conditionParamRef.questionTypeNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('questionTypeStart') and conditionParamRef.questionTypeStart != null">
                ${_conditionType_} a.questionType <![CDATA[ >= ]]> #{${_conditionParam_}.questionTypeStart}
            </if>
            <if test="conditionParamRef.containsKey('questionTypeEnd') and conditionParamRef.questionTypeEnd != null">
                ${_conditionType_} a.questionType <![CDATA[ <= ]]> #{${_conditionParam_}.questionTypeEnd}
            </if>

            <if test="conditionParamRef.containsKey('require')">
                <if test="conditionParamRef.require != null ">
                    ${_conditionType_} a.`require` = #{${_conditionParam_}.require}
                </if>
                <if test="conditionParamRef.require == null">
                    ${_conditionType_} a.`require` is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('requireList') and conditionParamRef.requireList.size() > 0">
                ${_conditionType_} a.`require` in
                <foreach collection="conditionParamRef.requireList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('requireNotList') and conditionParamRef.requireNotList.size() > 0">
                ${_conditionType_} a.`require` not in
                <foreach collection="conditionParamRef.requireNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('requireStart') and conditionParamRef.requireStart != null">
                ${_conditionType_} a.`require` <![CDATA[ >= ]]> #{${_conditionParam_}.requireStart}
            </if>
            <if test="conditionParamRef.containsKey('requireEnd') and conditionParamRef.requireEnd != null">
                ${_conditionType_} a.`require` <![CDATA[ <= ]]> #{${_conditionParam_}.requireEnd}
            </if>


            <if test="conditionParamRef.containsKey('style')">
                <if test="conditionParamRef.style != null and conditionParamRef.style != ''">
                    ${_conditionType_} a.style like #{${_conditionParam_}.style}
                </if>
                <if test="conditionParamRef.style == null">
                    ${_conditionType_} a.style is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('styleList') and conditionParamRef.styleList.size() > 0">
                ${_conditionType_} a.style in
                <foreach collection="conditionParamRef.styleList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('styleNotList') and conditionParamRef.styleNotList.size() > 0">
                ${_conditionType_} a.style not in
                <foreach collection="conditionParamRef.styleNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>

            <if test="conditionParamRef.containsKey('remark')">
                <if test="conditionParamRef.remark != null and conditionParamRef.remark != ''">
                    ${_conditionType_} a.remark like #{${_conditionParam_}.remark}
                </if>
                <if test="conditionParamRef.remark == null">
                    ${_conditionType_} a.remark is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('remarkList') and conditionParamRef.remarkList.size() > 0">
                ${_conditionType_} a.remark in
                <foreach collection="conditionParamRef.remarkList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('remarkNotList') and conditionParamRef.remarkNotList.size() > 0">
                ${_conditionType_} a.remark not in
                <foreach collection="conditionParamRef.remarkNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('createUserId')">
                <if test="conditionParamRef.createUserId != null ">
                    ${_conditionType_} a.createUserId = #{${_conditionParam_}.createUserId}
                </if>
                <if test="conditionParamRef.createUserId == null">
                    ${_conditionType_} a.createUserId is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('createUserIdList') and conditionParamRef.createUserIdList.size() > 0">
                ${_conditionType_} a.createUserId in
                <foreach collection="conditionParamRef.createUserIdList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('createUserIdNotList') and conditionParamRef.createUserIdNotList.size() > 0">
                ${_conditionType_} a.createUserId not in
                <foreach collection="conditionParamRef.createUserIdNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('createUserIdStart') and conditionParamRef.createUserIdStart != null">
                ${_conditionType_} a.createUserId <![CDATA[ >= ]]> #{${_conditionParam_}.createUserIdStart}
            </if>
            <if test="conditionParamRef.containsKey('createUserIdEnd') and conditionParamRef.createUserIdEnd != null">
                ${_conditionType_} a.createUserId <![CDATA[ <= ]]> #{${_conditionParam_}.createUserIdEnd}
            </if>


            <if test="conditionParamRef.containsKey('createTime')">
                <if test="conditionParamRef.createTime != null ">
                    ${_conditionType_} a.createTime = #{${_conditionParam_}.createTime}
                </if>
                <if test="conditionParamRef.createTime == null">
                    ${_conditionType_} a.createTime is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('createTimeStart') and conditionParamRef.createTimeStart != null and conditionParamRef.createTimeStart!=''">
                ${_conditionType_} a.createTime <![CDATA[ >= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.createTimeStart},' 00:00:00'),19),'%Y-%m-%d %k:%i:%s')
            </if>
            <if test="conditionParamRef.containsKey('createTimeEnd') and conditionParamRef.createTimeEnd != null and conditionParamRef.createTimeEnd!=''">
                ${_conditionType_} a.createTime <![CDATA[ <= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.createTimeEnd},' 23:59:59'),19),'%Y-%m-%d %k:%i:%s')
            </if>
            <if test="conditionParamRef.containsKey('updateUserId')">
                <if test="conditionParamRef.updateUserId != null ">
                    ${_conditionType_} a.updateUserId = #{${_conditionParam_}.updateUserId}
                </if>
                <if test="conditionParamRef.updateUserId == null">
                    ${_conditionType_} a.updateUserId is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('updateUserIdList') and conditionParamRef.updateUserIdList.size() > 0">
                ${_conditionType_} a.updateUserId in
                <foreach collection="conditionParamRef.updateUserIdList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('updateUserIdNotList') and conditionParamRef.updateUserIdNotList.size() > 0">
                ${_conditionType_} a.updateUserId not in
                <foreach collection="conditionParamRef.updateUserIdNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('updateUserIdStart') and conditionParamRef.updateUserIdStart != null">
                ${_conditionType_} a.updateUserId <![CDATA[ >= ]]> #{${_conditionParam_}.updateUserIdStart}
            </if>
            <if test="conditionParamRef.containsKey('updateUserIdEnd') and conditionParamRef.updateUserIdEnd != null">
                ${_conditionType_} a.updateUserId <![CDATA[ <= ]]> #{${_conditionParam_}.updateUserIdEnd}
            </if>


            <if test="conditionParamRef.containsKey('updateTime')">
                <if test="conditionParamRef.updateTime != null ">
                    ${_conditionType_} a.updateTime = #{${_conditionParam_}.updateTime}
                </if>
                <if test="conditionParamRef.updateTime == null">
                    ${_conditionType_} a.updateTime is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('updateTimeStart') and conditionParamRef.updateTimeStart != null and conditionParamRef.updateTimeStart!=''">
                ${_conditionType_} a.updateTime <![CDATA[ >= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.updateTimeStart},' 00:00:00'),19),'%Y-%m-%d %k:%i:%s')
            </if>
            <if test="conditionParamRef.containsKey('updateTimeEnd') and conditionParamRef.updateTimeEnd != null and conditionParamRef.updateTimeEnd!=''">
                ${_conditionType_} a.updateTime <![CDATA[ <= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.updateTimeEnd},' 23:59:59'),19),'%Y-%m-%d %k:%i:%s')
            </if>
    </sql>
    <sql id="_orderCols_">
        <if test="orderColList != null and !orderColList.isEmpty()">
            order by
            <trim suffixOverrides=","  suffix="">
                <foreach collection="orderColList" open="" close="" index="index" item="item" separator=",">
                     ${item.colName} ${item.sortKind}
                </foreach>
            </trim>
        </if>
        <if test="(orderColList == null or orderColList.isEmpty()) and orderCol != null and !orderCol.isEmpty()">
            order by
            <trim suffixOverrides=","  suffix="">
                    <if test="orderCol.containsKey('id')">
                        a.id
                        <if test='orderCol.id != null and "DESC".equalsIgnoreCase(orderCol.id)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('feedbackId')">
                        a.feedbackId
                        <if test='orderCol.feedbackId != null and "DESC".equalsIgnoreCase(orderCol.feedbackId)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('content')">
                        a.content
                        <if test='orderCol.content != null and "DESC".equalsIgnoreCase(orderCol.content)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('questionType')">
                        a.questionType
                        <if test='orderCol.questionType != null and "DESC".equalsIgnoreCase(orderCol.questionType)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('require')">
                        a.`require`
                        <if test='orderCol.require != null and "DESC".equalsIgnoreCase(orderCol.require)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('style')">
                        a.style
                        <if test='orderCol.style != null and "DESC".equalsIgnoreCase(orderCol.style)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('remark')">
                        a.remark
                        <if test='orderCol.remark != null and "DESC".equalsIgnoreCase(orderCol.remark)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('createUserId')">
                        a.createUserId
                        <if test='orderCol.createUserId != null and "DESC".equalsIgnoreCase(orderCol.createUserId)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('createTime')">
                        a.createTime
                        <if test='orderCol.createTime != null and "DESC".equalsIgnoreCase(orderCol.createTime)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('updateUserId')">
                        a.updateUserId
                        <if test='orderCol.updateUserId != null and "DESC".equalsIgnoreCase(orderCol.updateUserId)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('updateTime')">
                        a.updateTime
                        <if test='orderCol.updateTime != null and "DESC".equalsIgnoreCase(orderCol.updateTime)'>DESC</if>
                        ,
                    </if>
            </trim>
        </if>
    </sql>
    <sql id="_group_by_">
        <if test="groupList != null and !groupList.isEmpty()">
            GROUP BY
            <trim suffixOverrides=","  suffix="">
                <foreach collection="groupList" open="" close="" index="index" item="item" separator=",">
                    ${item}
                </foreach>
            </trim>
        </if>
    </sql>
</mapper>